-- "Northern Dungeon" is a modified copy of the "Dungeon" wall set from Legend of Grimrock
-- All original models, textures etc. used in this wall set are copyright (C) Almost Human Ltd.
-- Other original textures used copyright (C) Sirius-sdz.deviantart.com
-- All other content copyright (C) Daniv
-- For more details on using and redistributing these assets, please visit: http://www.grimrock.net/modding/modding-and-asset-usage-terms/

-- Version 1.3 created by Daniv
-- Last updated 4th October 2014



defineObject{
   name = "northern_dungeon_alcove",
   class = "Alcove",
   model = "mod_assets/models/northern_dungeon/northern_dungeon_wall_alcove.fbx",
   replacesWall = true,
   anchorPos = vec(0, 0.85, 0.2),
   targetPos = vec(0,1.3,0),
   targetSize = vec(0.6, 0.5, 0.6),
   placement = "wall",
   editorIcon = 8,
   }

defineObject{
   name = "northern_dungeon_altar",
   class = "Altar",
   model = "mod_assets/models/northern_dungeon/northern_dungeon_altar.fbx",
   placement = "floor",
   editorIcon = 52,
   }

defineObject{
   name = "northern_dungeon_bench",
   class = "Decoration",
   model = "mod_assets/models/northern_dungeon/northern_dungeon_bench.fbx",
   placement = "wall",
   editorIcon = 92,
   }

defineObject{
   name = "northern_dungeon_catacomb_empty",
   class = "Decoration",
   model = "mod_assets/models/northern_dungeon/northern_dungeon_catacomb_empty.fbx",
   placement = "wall",
   replacesWall = true,
   editorIcon = 92,
   }

defineObject{
   name = "northern_dungeon_catacomb_skeleton_down",
   class = "Decoration",
   model = "mod_assets/models/northern_dungeon/northern_dungeon_catacomb_skeleton_down.fbx",
   placement = "wall",
   replacesWall = true,
   editorIcon = 92,
   }

defineObject{
   name = "northern_dungeon_catacomb_skeleton_up",
   class = "Decoration",
   model = "mod_assets/models/northern_dungeon/northern_dungeon_catacomb_skeleton_up.fbx",
   placement = "wall",
   replacesWall = true,
   editorIcon = 92,
   }

defineObject{
   name = "northern_dungeon_cave_in",
   class = "Blockage",
   model = "mod_assets/models/northern_dungeon/northern_dungeon_cave_in.fbx",
   placement = "floor",
   repelProjectiles = true,
   hitSound = "impact_blade",
   editorIcon = 144,
   }

defineObject{
   name = "northern_dungeon_cave_in_ceiling",
   class = "Decoration",
   model = "mod_assets/models/northern_dungeon/northern_dungeon_cave_in_ceiling.fbx",
   placement = "ceiling",
   editorIcon = 144,
   }

defineObject{
   name = "northern_dungeon_ceiling_lantern",
   class = "Decoration",
   model = "mod_assets/models/northern_dungeon/northern_dungeon_ceiling_lantern.fbx",
   placement = "ceiling",
   editorIcon = 104,
   }

defineObject{
   name = "northern_dungeon_ceiling_lamp",
   class = "LightSource",
   lightPosition = vec(0, 3, 0),
   lightRange = 12,
   lightColor = vec(0.4, 0.43, 0.45),
   brightness = 5,
   castShadow = true,
   particleSystem = false,
   placement = "floor",
   editorIcon = 88,
   }

defineObject{
   name = "northern_dungeon_ceiling_root_1",
   class = "Decoration",
   model = "mod_assets/models/northern_dungeon/northern_dungeon_ceiling_roots_01.fbx",
   placement = "wall",
   editorIcon = 92,
   }

defineObject{
   name = "northern_dungeon_ceiling_root_2",
   class = "Decoration",
   model = "mod_assets/models/northern_dungeon/northern_dungeon_ceiling_roots_02.fbx",
   placement = "wall",
   editorIcon = 92,
   }

defineObject{
   name = "northern_dungeon_ceiling_root_3",
   class = "Decoration",
   model = "mod_assets/models/northern_dungeon/northern_dungeon_ceiling_roots_03.fbx",
   placement = "wall",
   editorIcon = 92,
   }

defineObject{
   name = "northern_dungeon_ceiling_shaft",
   class = "Decoration",
   model = "mod_assets/models/northern_dungeon/northern_dungeon_ceiling_shaft.fbx",
   placement = "ceiling",
   editorIcon = 104,
   }

defineObject{
   name = "northern_dungeon_daemon_head",
   class = "Decoration",
   model = "mod_assets/models/northern_dungeon/northern_dungeon_daemon_head.fbx",
   placement = "wall",
   editorIcon = 92,
   }

defineObject{
   name = "northern_dungeon_daemon_head_eye_slots",
   class = "Decoration",
   model = "mod_assets/models/northern_dungeon/northern_dungeon_daemon_head_puzzle.fbx",
   placement = "wall",
   editorIcon = 92,
   }

defineObject{
   name = "northern_dungeon_door_iron",
   class = "Door",
   model = "mod_assets/models/northern_dungeon/northern_dungeon_iron_door.fbx",
   doorFrameModel = "mod_assets/models/northern_dungeon/northern_dungeon_door_frame_wide.fbx",
   pullChainModel = "assets/models/env/door_pullchain.fbx",
   pullChainAnim = "assets/animations/env/door_pullchain.fbx",
   openSound = "gate_iron_open",
   closeSound = "gate_iron_close",
   lockSound = "gate_lock",
   killPillars = true,
   doubleDoor = true,
   openVelocity = 1.1,
   closeVelocity = -1.1,
   closeAcceleration = 0,
   placement = "wall",
   editorIcon = 16,
   }

defineObject{
   name = "northern_dungeon_door_metal",
   class = "Door",
   model = "mod_assets/models/northern_dungeon/northern_dungeon_metal_door.fbx",
   doorFrameModel = "mod_assets/models/northern_dungeon/northern_dungeon_door_frame.fbx",
   pullChainModel = "assets/models/env/door_pullchain.fbx",
   pullChainAnim = "assets/animations/env/door_pullchain.fbx",
   openSound = "gate_open",
   closeSound = "gate_close",
   lockSound = "gate_lock",
   killPillars = true,
   openVelocity = 1.3,
   closeVelocity = 0,
   closeAcceleration = -10,
   placement = "wall",
   editorIcon = 124,
   }

defineObject{
   name = "northern_dungeon_door_ornament",
   class = "Door",
   model = "mod_assets/models/northern_dungeon/northern_dungeon_ornament_door.fbx",
   doorFrameModel = "mod_assets/models/northern_dungeon/northern_dungeon_door_frame.fbx",
   pullChainModel = "assets/models/env/door_pullchain.fbx",
   pullChainAnim = "assets/animations/env/door_pullchain.fbx",
   openSound = "gate_open",
   closeSound = "gate_close",
   lockSound = "gate_lock",
   killPillars = true,
   openVelocity = 1.3,
   closeVelocity = 0,
   closeAcceleration = -10,
   placement = "wall",
   editorIcon = 124,
   }

defineObject{
   name = "northern_dungeon_door_portcullis",
   class = "Door",
   model = "mod_assets/models/northern_dungeon/northern_dungeon_portcullis_door.fbx",
   doorFrameModel = "mod_assets/models/northern_dungeon/northern_dungeon_door_frame.fbx",
   pullChainModel = "assets/models/env/door_pullchain.fbx",
   pullChainAnim = "assets/animations/env/door_pullchain.fbx",
   openSound = "gate_open",
   closeSound = "gate_close",
   lockSound = "gate_lock",
   killPillars = true,
   openVelocity = 1.3,
   closeVelocity = 0,
   closeAcceleration = -10,
   sparse = true,
   placement = "wall",
   editorIcon = 124,
   }

defineObject{
   name = "northern_dungeon_door_steel",
   class = "Door",
   model = "mod_assets/models/northern_dungeon/northern_dungeon_steel_door.fbx",
   doorFrameModel = "mod_assets/models/northern_dungeon/northern_dungeon_door_frame_wide.fbx",
   pullChainModel = "assets/models/env/door_pullchain.fbx",
   pullChainAnim = "assets/animations/env/door_pullchain.fbx",
   openSound = "gate_iron_open",
   closeSound = "gate_iron_close",
   lockSound = "gate_lock",
   killPillars = true,
   doubleDoor = true,
   openVelocity = 1.1,
   closeVelocity = -1.1,
   closeAcceleration = 0,
   placement = "wall",
   editorIcon = 16,
   }

defineObject{
   name = "northern_dungeon_door_wooden",
   class = "Door",
   model = "mod_assets/models/northern_dungeon/northern_dungeon_wooden_door.fbx",
   doorFrameModel = "mod_assets/models/northern_dungeon/northern_dungeon_door_frame.fbx",
   pullChainModel = "assets/models/env/door_pullchain.fbx",
   pullChainAnim = "assets/animations/env/door_pullchain.fbx",
   openSound = "gate_open",
   closeSound = "gate_close",
   lockSound = "gate_lock",
   killPillars = true,
   openVelocity = 1.3,
   closeVelocity = 0,
   closeAcceleration = -10,
   placement = "wall",
   editorIcon = 128,
   }

defineObject{
   name = "northern_dungeon_door_wooden_locked",
   class = "Door",
   model = "mod_assets/models/northern_dungeon/northern_dungeon_wooden_locked_door.fbx",
   doorFrameModel = "mod_assets/models/northern_dungeon/northern_dungeon_door_frame.fbx",
   pullChainModel = "assets/models/env/door_pullchain.fbx",
   pullChainAnim = "assets/animations/env/door_pullchain.fbx",
   openSound = "gate_open",
   closeSound = "gate_close",
   lockSound = "gate_lock",
   killPillars = true,
   openVelocity = 1.3,
   closeVelocity = 0,
   closeAcceleration = -10,
   locked = true,
   lockPos = vec(0, 1.05, 0),
   lockSize = vec(100, 140),
   placement = "wall",
   editorIcon = 128,
   }

defineObject{
   name = "northern_dungeon_dragon_statue",
   class = "Blockage",
   model = "mod_assets/models/northern_dungeon/northern_dungeon_dragon_statue.fbx",
   placement = "floor",
   repelProjectiles = true,
   hitSound = "impact_blade",
   editorIcon = 56,
   }

defineObject{
   name = "northern_dungeon_floor_corpse_1",
   class = "Decoration",
   model = "mod_assets/models/northern_dungeon/northern_dungeon_floor_corpse_01.fbx",
   placement = "floor",
   editorIcon = 100,
   }

defineObject{
   name = "northern_dungeon_floor_corpse_2",
   class = "Decoration",
   model = "mod_assets/models/northern_dungeon/northern_dungeon_floor_corpse_02.fbx",
   placement = "floor",
   editorIcon = 100,
   }

defineObject{
   name = "northern_dungeon_floor_drainage",
   class = "Decoration",
   model = "mod_assets/models/northern_dungeon/northern_dungeon_floor_drainage.fbx",
   placement = "floor",
   replacesFloor = true,
   editorIcon = 136,
   }

defineObject{
   name = "northern_dungeon_goromorg_fourway",
   class = "Blockage",
   model = "mod_assets/models/northern_dungeon/northern_dungeon_goromorg_statue_fourway.fbx",
   placement = "floor",
   repelProjectiles = true,
   hitSound = "impact_blade",
   editorIcon = 56,
   }

defineObject{
   name = "northern_dungeon_goromorg_statue",
   class = "Decoration",
   model = "mod_assets/models/northern_dungeon/northern_dungeon_goromorg_statue.fbx",
   placement = "wall",
   replacesWall = true,
   statueBase = true,
   editorIcon = 92,
   }

defineObject{
   name = "northern_dungeon_ivy_1",
   class = "Decoration",
   model = "mod_assets/models/northern_dungeon/northern_dungeon_ivy_01.fbx",
   placement = "wall",
   editorIcon = 92,
   }

defineObject{
   name = "northern_dungeon_ivy_2",
   class = "Decoration",
   model = "mod_assets/models/northern_dungeon/northern_dungeon_ivy_02.fbx",
   placement = "wall",
   editorIcon = 92,
   }

defineObject{
   name = "northern_dungeon_pillar",
   class = "Decoration",
   model = "mod_assets/models/northern_dungeon/northern_dungeon_pillar.fbx",
   placement = "pillar",
   editorIcon = 108,
   }

defineObject{
   name = "northern_dungeon_pit",
   class = "Pit",
   model = "mod_assets/models/northern_dungeon/northern_dungeon_pit.fbx",
   trapDoorModel = "mod_assets/models/northern_dungeon/northern_dungeon_pit_trapdoor.fbx",
   openAnim = "assets/animations/env/temple_pit_trapdoor_open.fbx",
   closeAnim = "assets/animations/env/temple_pit_trapdoor_close.fbx",
   placement = "floor",
   editorIcon = 40,
   }

defineObject{
   name = "northern_dungeon_pressure_plate",
   class = "PressurePlate",
   model = "mod_assets/models/northern_dungeon/northern_dungeon_pressure_plate.fbx",
   activateAnim = "assets/animations/env/dungeon_pressure_plate_down.fbx",
   deactivateAnim = "assets/animations/env/dungeon_pressure_plate_up.fbx",	
   placement = "floor",
   editorIcon = 0,
   }

defineObject{
   name = "northern_dungeon_receptor",
   class = "Receptor",
   model = "mod_assets/models/northern_dungeon/northern_dungeon_spell_receptor.fbx",
   placement = "wall",
   editorIcon = 72,
   }

defineObject{
   name = "northern_dungeon_secret_button_large",
   class = "Button",
   model = "mod_assets/models/northern_dungeon/northern_dungeon_secret_button_large.fbx",
   pressAnim = "assets/animations/env/dungeon_secret_button_large_press.fbx",
   replacesWall = true,
   placement = "wall",
   editorIcon = 12,
   }

defineObject{
   name = "northern_dungeon_secret_button_small",
   class = "Button",
   model = "mod_assets/models/northern_dungeon/northern_dungeon_secret_button_small.fbx",
   pressAnim = "assets/animations/env/dungeon_secret_button_small_press.fbx",
   replacesWall = true,
   placement = "wall",
   editorIcon = 12,
   }

defineObject{
   name = "northern_dungeon_secret_door",
   class = "Door",
   model = "mod_assets/models/northern_dungeon/northern_dungeon_secret_door.fbx",
   openSound = "wall_sliding",
   closeSound = "wall_sliding",
   lockSound = "wall_sliding_lock",
   openVelocity = 0.5,
   closeVelocity = -0.5,
   secretDoor = true,
   placement = "wall",
   editorIcon = 120,
   }

defineObject{
   name = "northern_dungeon_stairs_down",
   class = "Stairs",
   model = "mod_assets/models/northern_dungeon/northern_dungeon_stairs_down.fbx",
   down = true,
   editorIcon = 48,
   }

defineObject{
   name = "northern_dungeon_stairs_up",
   class = "Stairs",
   model = "mod_assets/models/northern_dungeon/northern_dungeon_stairs_up.fbx",
   down = false,
   editorIcon = 44,
   }

defineObject{
   name = "northern_dungeon_wall_drainage",
   class = "Decoration",
   model = "mod_assets/models/northern_dungeon/northern_dungeon_wall_drainage.fbx",
   placement = "wall",
   replacesWall = true,
   editorIcon = 92,
   }

defineObject{
   name = "northern_dungeon_wall_grating",
   class = "Door",
   model = "mod_assets/models/northern_dungeon/northern_dungeon_wall_grating.fbx",
   openSound = "gate_open",
   closeSound = "gate_close",
   lockSound = "gate_lock",
   openVelocity = 1.3,
   closeVelocity = 0,
   closeAcceleration = -10,
   sparse = true,
   placement = "wall",
   editorIcon = 132,
   }

defineObject{
   name = "northern_dungeon_wall_text",
   class = "WallText",
   model = "mod_assets/models/northern_dungeon/northern_dungeon_wall_text.fbx",
   placement = "wall",
   replacesWall = true,
   editorIcon = 28,
   }

defineObject{
   name = "northern_dungeon_wall_text_long",
   class = "WallText",
   model = "mod_assets/models/northern_dungeon/northern_dungeon_wall_text_long.fbx",
   placement = "wall",
   replacesWall = true,
   editorIcon = 28,
   }



-- Healing Crystal

defineParticleSystem{
   name = "northern_crystal",
   emitters = {
      {
         emissionRate = 15,
         emissionTime = 0,
         maxParticles = 1000,
         boxMin = {-0.2, 0.8,-0.2},
         boxMax = { 0.2, 2, 0.2},
         sprayAngle = {0,360},
         velocity = {0,0},
         objectSpace = true,
         texture = "assets/textures/particles/lightning01.tga",
         frameRate = 4,
         frameSize = 256,
         frameCount = 4,
         lifetime = {0.5,0.3},
         color0 = {1.5,1.5,1.5},
         opacity = 1,
         fadeIn = 0.1,
         fadeOut = 0.1,
         size = {0.25, 2.0},
         gravity = {0,0,0},
         airResistance = 5,
         rotationSpeed = 0.5,
         blendMode = "Additive",
         },
      {
         emissionRate = 10,
         emissionTime = 0,
         maxParticles = 1000,
         boxMin = {-0.2, 0.8,-0.2},
         boxMax = { 0.2, 2, 0.2},
         sprayAngle = {0,360},
         velocity = {0,0},
         objectSpace = true,
         texture = "assets/textures/particles/lightning01.tga",
         frameRate = 4,
         frameSize = 256,
         frameCount = 4,
         lifetime = {0.5,0.3},
         color0 = {1.5,1.5,1.5},
         opacity = 1,
         fadeIn = 0.1,
         fadeOut = 0.1,
         size = {0.2, 0.7},
         gravity = {0,0,0},
         airResistance = 5,
         rotationSpeed = 0.5,
         blendMode = "Additive",
         },
      {
         emissionRate = 10,
         emissionTime = 0,
         maxParticles = 1000,
         boxMin = {-0.5, 0.0,-0.5},
         boxMax = { 0.5, 2.5, 0.5},
         sprayAngle = {0,360},
         velocity = {0.1,0.2},
         objectSpace = true,
         texture = "assets/textures/particles/fog.tga",
         lifetime = {3,3},
         color0 = {0.152941, 0.352941, 0.803922},
         opacity = 1,
         fadeIn = 2.2,
         fadeOut = 2.2,
         size = {1.5, 1.5},
         gravity = {0,0,0},
         airResistance = 0.1,
         rotationSpeed = 0.3,
         blendMode = "Additive",
         },
      {
         emissionRate = 200,
         emissionTime = 0,
         maxParticles = 1000,
         boxMin = {-0.6, 0.3,-0.6},
         boxMax = { 0.6, 2.5, 0.6},
         sprayAngle = {0,360},
         velocity = {0.2,0.2},
         objectSpace = true,
         texture = "assets/textures/particles/teleporter.tga",
         lifetime = {1,1},
         color0 = {3.0,3.0,3.0},
         opacity = 1,
         fadeIn = 0.1,
         fadeOut = 0.1,
         size = {0.05, 0.13},
         gravity = {0,0,0},
         airResistance = 0.1,
         rotationSpeed = 2,
         blendMode = "Additive",
         },
      {
         emissionRate = 200,
         emissionTime = 0,
         maxParticles = 1000,
         boxMin = {-0.6, 0,-0.6},
         boxMax = { 0.6, 3, 0.6},
         sprayAngle = {0,360},
         velocity = {0.2,0.2},
         objectSpace = true,
         texture = "assets/textures/particles/teleporter.tga",
         lifetime = {1,1},
         color0 = {3.0,3.0,3.0},
         opacity = 1,
         fadeIn = 0.1,
         fadeOut = 0.1,
         size = {0.05, 0.13},
         gravity = {0,0.75,0},
         airResistance = 0.1,
         rotationSpeed = 2,
         blendMode = "Additive",
         },
      {
         emissionRate = 200,
         emissionTime = 0,
         maxParticles = 1000,
         boxMin = {-1, 0,-1},
         boxMax = { 1, 3, 1},
         sprayAngle = {0,360},
         velocity = {0.2,0.2},
         objectSpace = true,
         texture = "assets/textures/particles/teleporter.tga",
         lifetime = {1,1},
         color0 = {3.0,3.0,3.0},
         opacity = 1,
         fadeIn = 0.1,
         fadeOut = 0.1,
         size = {0.05, 0.13},
         gravity = {0,0.5,0},
         airResistance = 0.1,
         rotationSpeed = 2,
         blendMode = "Additive",
         }
      }
   }

defineObject{
   name = "northern_dungeon_healing_crystal",
   class = "Crystal",
   model = "assets/models/env/healing_crystal.fbx",
   animation = "assets/animations/env/healing_crystal_spin.fbx",
   particleSystem = "northern_crystal",
   placement = "floor",
   editorIcon = 60,
   }



-- Ogre

defineObject{
   name = "northern_ogre",
   class = "Monster",
   model = "mod_assets/models/northern_dungeon/northern_dungeon_tunnel_ogre.fbx",
   meshName = "tunnel_ogre_mesh",
   animations = {
      idle = "assets/animations/monsters/tunnel_ogre/tunnel_ogre_idle.fbx",
      moveForward = "assets/animations/monsters/tunnel_ogre/tunnel_ogre_walk.fbx",
      turnLeft = "assets/animations/monsters/tunnel_ogre/tunnel_ogre_turn_left.fbx",
      turnRight = "assets/animations/monsters/tunnel_ogre/tunnel_ogre_turn_right.fbx",
      attack = "assets/animations/monsters/tunnel_ogre/tunnel_ogre_attack.fbx",
      attack2 = "assets/animations/monsters/tunnel_ogre/tunnel_ogre_attack_stab.fbx",
      --attack3 = "assets/animations/monsters/tunnel_ogre/tunnel_ogre_attack_two_handed.fbx",
      --attack4 = "assets/animations/monsters/tunnel_ogre/tunnel_ogre_attack_leap.fbx",
      turnAttackLeft =  "assets/animations/monsters/tunnel_ogre/tunnel_ogre_attack_left.fbx",
      turnAttackRight =  "assets/animations/monsters/tunnel_ogre/tunnel_ogre_attack_right.fbx",
      getHitFrontLeft = "assets/animations/monsters/tunnel_ogre/tunnel_ogre_get_hit_front_left_02.fbx",
      getHitFrontRight = "assets/animations/monsters/tunnel_ogre/tunnel_ogre_get_hit_front_right_02.fbx",
      getHitBack = "assets/animations/monsters/tunnel_ogre/tunnel_ogre_get_hit_back_02.fbx",
      getHitLeft = "assets/animations/monsters/tunnel_ogre/tunnel_ogre_get_hit_left_02.fbx",
      getHitRight = "assets/animations/monsters/tunnel_ogre/tunnel_ogre_get_hit_right_02.fbx",
      fall = "assets/animations/monsters/tunnel_ogre/tunnel_ogre_get_hit_back_02.fbx",
      rushBegin = "assets/animations/monsters/tunnel_ogre/tunnel_ogre_rush_begin.fbx",
      rushContinue1 = "assets/animations/monsters/tunnel_ogre/tunnel_ogre_rush_continue_right_step.fbx",
      rushContinue2 = "assets/animations/monsters/tunnel_ogre/tunnel_ogre_rush_continue_left_step.fbx",
      rushHit1 = "assets/animations/monsters/tunnel_ogre/tunnel_ogre_rush_hit_right_step.fbx",
      rushHit2 = "assets/animations/monsters/tunnel_ogre/tunnel_ogre_rush_hit_left_step.fbx",
      },
   moveSound = "ogre_walk",
   footstepSound = "ogre_footstep",
   attackSound = "ogre_attack",
   hitSound = "ogre_hit",
   impactSound = "ogre_impact",
   dieSound = "ogre_die",
   rushBeginSound = "ogre_rush_begin",
   --soundClipDistance = 8,
   hitEffect = "hit_blood",
   capsuleHeight = 0.6,
   capsuleRadius = 0.6,
   health = 1050,
   sight = 4,
   attackPower = 90,
   accuracy = 40,
   protection = 25,
   evasion = -5,
   coolDown = { 2, 3 },
   movementCoolDown = 2,
   noRecoilInterval = { 0.1, 1.0 }, -- interval must end at 1, otherwise turn attack can be interrupted (looks ugly)
   exp = 1125,
   lootDrop = { 100, "ogre_hammer" },	
   healthIncrement = 75,
   attackPowerIncrement = 15,
   protectionIncrement = 2,
   brain = "Ogre",
   onDealDamage = function(self, champion, damage)
      party:shakeCamera(0.5, 0.3)
      party:playScreenEffect("damage_screen")
      end
   }

